diff -cr sendmail-8.9.0/cf/cf/knecht.mc sendmail-8.9.1/cf/cf/knecht.mc
*** sendmail-8.9.0/cf/cf/knecht.mc	Tue May 19 16:34:11 1998
--- sendmail-8.9.1/cf/cf/knecht.mc	Thu Jun 11 13:33:12 1998
***************
*** 16,22 ****
  #
  
  divert(0)dnl
! VERSIONID(`@(#)knecht.mc	8.28 (Berkeley) 5/19/98')
  OSTYPE(bsd4.4)dnl
  DOMAIN(generic)dnl
  define(`confFORWARD_PATH', `$z/.forward.$w:$z/.forward+$h:$z/.forward')dnl
--- 16,22 ----
  #
  
  divert(0)dnl
! VERSIONID(`@(#)knecht.mc	8.30 (Berkeley) 6/11/98')
  OSTYPE(bsd4.4)dnl
  DOMAIN(generic)dnl
  define(`confFORWARD_PATH', `$z/.forward.$w:$z/.forward+$h:$z/.forward')dnl
***************
*** 25,30 ****
--- 25,31 ----
  define(`confTO_ICONNECT', `10s')dnl
  define(`confCOPY_ERRORS_TO', `Postmaster')dnl
  define(`confTO_QUEUEWARN', `8h')dnl
+ define(`confTRUSTED_USERS', `www')dnl
  define(`confPRIVACY_FLAGS', ``authwarnings,noexpn,novrfy'')dnl
  FEATURE(virtusertable)dnl
  FEATURE(access_db)dnl
***************
*** 43,53 ****
  Kcheckaddress regex -a@MATCH
     ^([0-9]+<@(aol|msn)\.com|[0-9][^<]*<@juno\.com|.{10}[^<]+<@aol\.com)\.?>
  
  LOCAL_RULESETS
  HTo: $>CheckTo
  
  SCheckTo
! Rfriend@$*			$#error $: "553 Header error"
  
  HMessage-Id: $>CheckMessageId
  
--- 44,61 ----
  Kcheckaddress regex -a@MATCH
     ^([0-9]+<@(aol|msn)\.com|[0-9][^<]*<@juno\.com|.{10}[^<]+<@aol\.com)\.?>
  
+ #
+ #  Names that won't be allowed in a To: line (local-part and domains)
+ #
+ C{RejectToLocalparts}	friend you
+ C{RejectToDomains}	public.com
+ 
  LOCAL_RULESETS
  HTo: $>CheckTo
  
  SCheckTo
! R$={RejectToLocalparts}@$*	$#error $: "553 Header error"
! R$*@$={RejectToDomains}		$#error $: "553 Header error"
  
  HMessage-Id: $>CheckMessageId
  
diff -cr sendmail-8.9.0/cf/m4/proto.m4 sendmail-8.9.1/cf/m4/proto.m4
*** sendmail-8.9.0/cf/m4/proto.m4	Tue May 19 16:34:41 1998
--- sendmail-8.9.1/cf/m4/proto.m4	Tue Jun 30 11:23:41 1998
***************
*** 12,18 ****
  #
  divert(0)
  
! VERSIONID(`@(#)proto.m4	8.218 (Berkeley) 5/19/98')
  
  MAILER(local)dnl
  
--- 12,18 ----
  #
  divert(0)
  
! VERSIONID(`@(#)proto.m4	8.223 (Berkeley) 6/30/98')
  
  MAILER(local)dnl
  
***************
*** 711,716 ****
--- 711,717 ----
  SParse0
  R<@>			$@ <@>			special case error msgs
  R$* : $* ; <@>		$#error $@ 5.1.3 $: "List:; syntax illegal for recipient addresses"
+ #R@ <@ $* >		< @ $1 >		catch "@@host" bogosity
  R<@ $+>			$#error $@ 5.1.3 $: "User address required"
  R$*			$: <> $1
  R<> $* < @ [ $+ ] > $*	$1 < @ [ $2 ] > $3
***************
*** 1084,1089 ****
--- 1085,1092 ----
  R<>			$@ <OK>
  R$*			$: <?> $>Parse0 $>3 $1		make domain canonical
  R<?> $* < @ $+ . > $*	<?> $1 < @ $2 > $3		strip trailing dots
+ # handle non-DNS hostnames (*.bitnet, *.decnet, *.uucp, etc)
+ R<?> $* < $* $=P > $*	$: <OK> $1 < @ $2 $3 > $4
  ifdef(`_ACCEPT_UNRESOLVABLE_DOMAINS_',
  `R<?> $* < @ $+ > $*	$: <OK> $1 < @ $2 > $3		... unresolvable OK',
  `R<?> $* < @ $+ > $*	$: <? $(resolve $2 $: $2 <PERM> $) > $1 < @ $2 > $3
***************
*** 1201,1213 ****
  R<$*> $*			$: $2',
  `dnl')
  
! # local user
! R$-			$@ OK
  
  # anything originating locally is ok
! R$*			$: $&{client_name}
  # pass to name server to make hostname canonical
! R$* $~P 		$: $[ $1 $2 $]
  R$* .			$1				strip trailing dots
  R$@			$@ OK
  ifdef(`_RELAY_ENTIRE_DOMAIN_', `dnl
--- 1204,1223 ----
  R<$*> $*			$: $2',
  `dnl')
  
! # check for local user (i.e. unqualified address)
! R$*			$: <?> $1
! R<?> $+ < @ $+ >	$: <REMOTE> $1 < @ $2 >
! # local user is ok
! R<?> $+			$@ OK
! R<$+> $*		$: $2
  
  # anything originating locally is ok
! R$*			$: <?> $&{client_name}
! # check if bracketed IP address (forward lookup != reverse lookup)
! R<?> [$+]		$: <BAD> [$1]
  # pass to name server to make hostname canonical
! R<?> $* $~P 		$: <?> $[ $1 $2 $]
! R<$-> $*		$: $2
  R$* .			$1				strip trailing dots
  R$@			$@ OK
  ifdef(`_RELAY_ENTIRE_DOMAIN_', `dnl
***************
*** 1227,1232 ****
--- 1237,1243 ----
  # check IP address
  R$*			$: $&{client_addr}
  R$@			$@ OK			originated locally
+ R0			$@ OK			originated locally
  R$=R $*			$@ OK			relayable IP address
  ifdef(`ACCESS_TABLE', `dnl
  R$*			$: $>LookUpAddress <$1> <?> <$1>
diff -cr sendmail-8.9.0/cf/m4/version.m4 sendmail-8.9.1/cf/m4/version.m4
*** sendmail-8.9.0/cf/m4/version.m4	Tue May 19 16:34:41 1998
--- sendmail-8.9.1/cf/m4/version.m4	Thu Jul  2 11:05:26 1998
***************
*** 10,17 ****
  # the sendmail distribution.
  #
  #
! VERSIONID(`@(#)version.m4	8.9 (Berkeley) 5/19/98')
  #
  divert(0)
  # Configuration version number
! DZ8.9.0`'ifdef(`confCF_VERSION', `/confCF_VERSION')
--- 10,17 ----
  # the sendmail distribution.
  #
  #
! VERSIONID(`@(#)version.m4	8.9.1.1 (Berkeley) 7/2/98')
  #
  divert(0)
  # Configuration version number
! DZ8.9.1`'ifdef(`confCF_VERSION', `/confCF_VERSION')
diff -cr sendmail-8.9.0/cf/mailer/local.m4 sendmail-8.9.1/cf/mailer/local.m4
*** sendmail-8.9.0/cf/mailer/local.m4	Tue May 19 16:34:46 1998
--- sendmail-8.9.1/cf/mailer/local.m4	Tue Jun 30 11:28:18 1998
***************
*** 23,29 ****
  ###   Local and Program Mailer specification   ###
  ##################################################
  
! VERSIONID(`@(#)local.m4	8.29 (Berkeley) 5/19/98')
  
  Mlocal,		P=LOCAL_MAILER_PATH, F=CONCAT(`lsDFMAw5:/|@q', LOCAL_MAILER_FLAGS), S=10/30, R=20/40,
  		_OPTINS(`LOCAL_MAILER_MAX', `M=', `, ')_OPTINS(`LOCAL_MAILER_CHARSET', `C=', `, ')T=DNS/RFC822/X-Unix,
--- 23,29 ----
  ###   Local and Program Mailer specification   ###
  ##################################################
  
! VERSIONID(`@(#)local.m4	8.30 (Berkeley) 6/30/98')
  
  Mlocal,		P=LOCAL_MAILER_PATH, F=CONCAT(`lsDFMAw5:/|@q', LOCAL_MAILER_FLAGS), S=10/30, R=20/40,
  		_OPTINS(`LOCAL_MAILER_MAX', `M=', `, ')_OPTINS(`LOCAL_MAILER_CHARSET', `C=', `, ')T=DNS/RFC822/X-Unix,
***************
*** 37,42 ****
--- 37,43 ----
  #
  S10
  R<@>			$n			errors to mailer-daemon
+ R@ <@ $*>		$n			temporarily bypass Sun bogosity
  R$+			$: $>50 $1		add local domain if needed
  R$*			$: $>94 $1		do masquerading
  
***************
*** 51,56 ****
--- 52,58 ----
  #
  S30
  R<@>			$n			errors to mailer-daemon
+ R@ <@ $*>		$n			temporarily bypass Sun bogosity
  R$+			$: $>50 $1		add local domain if needed
  R$*			$: $>93 $1		do masquerading
  
diff -cr sendmail-8.9.0/doc/op/op.me sendmail-8.9.1/doc/op/op.me
*** sendmail-8.9.0/doc/op/op.me	Tue May 19 16:35:18 1998
--- sendmail-8.9.1/doc/op/op.me	Mon Jun 29 17:09:19 1998
***************
*** 8,14 ****
  .\" the sendmail distribution.
  .\"
  .\"
! .\"	@(#)op.me	8.127 (Berkeley) 5/19/98
  .\"
  .\" eqn op.me | pic | troff -me
  .eh 'SMM:08-%''Sendmail Installation and Operation Guide'
--- 8,14 ----
  .\" the sendmail distribution.
  .\"
  .\"
! .\"	@(#)op.me	8.129 (Berkeley) 6/29/98
  .\"
  .\" eqn op.me | pic | troff -me
  .eh 'SMM:08-%''Sendmail Installation and Operation Guide'
***************
*** 46,52 ****
  Sendmail, Inc.
  eric@Sendmail.COM
  .sp
! Version 8.127
  .sp
  For Sendmail Version 8.9
  .)l
--- 46,52 ----
  Sendmail, Inc.
  eric@Sendmail.COM
  .sp
! Version 8.129
  .sp
  For Sendmail Version 8.9
  .)l
***************
*** 613,619 ****
  in a fashion similar to
  .i newaliases .
  This command lists the status of the last mail transaction
! with all remote hosts.
  It functions only when the
  .b HostStatusDirectory
  option is set.
--- 613,621 ----
  in a fashion similar to
  .i newaliases .
  This command lists the status of the last mail transaction
! with all remote hosts.  The
! .b \-v
! flag will prevent the status display from being truncated.
  It functions only when the
  .b HostStatusDirectory
  option is set.
***************
*** 728,733 ****
--- 730,736 ----
  for an example of a complex script which does this clean up.
  .(z
  .hl
+ #!/bin/sh
  # remove zero length qf files
  for qffile in qf*
  do
***************
*** 749,756 ****
  		echo \-n " <recovering: $tffile>" > /dev/console
  		mv $tffile $qffile
  	else
! 		echo \-n " <extra: $tffile>" > /dev/console
! 		rm \-f $tffile
  	fi
  done
  # remove df files with no corresponding qf files
--- 752,762 ----
  		echo \-n " <recovering: $tffile>" > /dev/console
  		mv $tffile $qffile
  	else
! 		if [ \-f $tffile ]
! 		then
! 			echo \-n " <extra: $tffile>" > /dev/console
! 			rm \-f $tffile
! 		fi
  	fi
  done
  # remove df files with no corresponding qf files
***************
*** 766,772 ****
  # announce files that have been saved during disaster recovery
  for xffile in [A-Z]f*
  do
! 	echo \-n " <panic: $xffile>" > /dev/console
  done
  .sp
  .ce
--- 772,781 ----
  # announce files that have been saved during disaster recovery
  for xffile in [A-Z]f*
  do
! 	if [ \-f $xffile ]
! 	then
! 		echo \-n " <panic: $xffile>" > /dev/console
! 	fi
  done
  .sp
  .ce
***************
*** 8193,8199 ****
  .\".sz 10
  .\"Eric Allman
  .\".sp
! .\"Version 8.127
  .\".ce 0
  .bp 3
  .ce
--- 8202,8208 ----
  .\".sz 10
  .\"Eric Allman
  .\".sp
! .\"Version 8.129
  .\".ce 0
  .bp 3
  .ce
diff -cr sendmail-8.9.0/mail.local/Build sendmail-8.9.1/mail.local/Build
*** sendmail-8.9.0/mail.local/Build	Tue May 19 16:33:54 1998
--- sendmail-8.9.1/mail.local/Build	Wed Jun 24 21:10:11 1998
***************
*** 10,16 ****
  # the sendmail distribution.
  #
  #
! #       @(#)Build	8.88 (Berkeley) 5/19/98
  #
  
  #
--- 10,16 ----
  # the sendmail distribution.
  #
  #
! #       @(#)Build	8.93 (Berkeley) 6/24/98
  #
  
  #
***************
*** 155,160 ****
--- 155,166 ----
  		rel=Mach
  		arch=luna88k
  	fi
+ elif [ -d /usr/apollo -a -d \`node_data ]
+ then
+ 	# probably a Apollo/DOMAIN
+ 	os=DomainOS
+ 	arch=$ISP
+ 	rel=`/usr/apollo/bin/bldt | grep Domain | awk '{ print $4 }' | sed -e 's/,//g'`
  fi
  
  if [ ! "$arch" -a ! "$os" -a ! "$rel" ]
***************
*** 234,239 ****
--- 240,249 ----
  			rel=`uname -v | sed -e 's/\(V.*\)L.*/\1/'`
  		fi;;
    SINIX-?)	os=SINIX;;
+   DomainOS)	case $rel in
+ 		  10.4*)	rel=10.4;;
+ 		esac
+ 		;;
  esac
  
  # get "base part" of operating system release
***************
*** 296,301 ****
--- 306,317 ----
  BUILDTOOLS=${BUILDTOOLS-$SMROOT/BuildTools}
  export SMROOT BUILDTOOLS
  
+ # see if we are in a Build-able directory
+ if [ ! -f Makefile.m4 ]; then
+ 	echo "Makefile.m4 not found.  Build can only be run from a source directory."
+ 	exit $EX_UNAVAILABLE
+ fi
+ 
  # now try to find a reasonable object directory
  if [ -r obj.$os.$rel.$arch$sfx ]; then
  	obj=obj.$os.$rel.$arch$sfx
***************
*** 436,442 ****
  		fi
  		if [ -f $BUILDTOOLS/Site/site.config.m4 ]
  		then
! 			siteconfig=$BUILDTOOLS/Site/site.config.m4
  		fi
  	fi
  	if [ ! -z "$siteconfig" ]
--- 452,458 ----
  		fi
  		if [ -f $BUILDTOOLS/Site/site.config.m4 ]
  		then
! 			siteconfig="$BUILDTOOLS/Site/site.config.m4 $siteconfig"
  		fi
  	fi
  	if [ ! -z "$siteconfig" ]
***************
*** 454,474 ****
  	fi
  	echo 'divert(0)dnl' >> $obj/.settings$$
  	libdirs=`(cat $obj/.settings$$; echo "_SRIDBIL_= confLIBDIRS" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_SRIDBIL_=" | \
! 		sed -e 's/_include_/include/g' -e "s/^_SRIDBIL_=//"`
  	libsrch=`(cat $obj/.settings$$; echo "_HCRSBIL_= confLIBSEARCH" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_HCRSBIL_=" | \
! 		sed -e 's/_include_/include/g' -e "s/^_HCRSBIL_=//"`
  	echo 'divert(-1)' >> $obj/.settings$$
  	LIBDIRS="$libdirs" LIBSRCH="$libsrch" SITECONFIG="$siteconfig" sh $BUILDTOOLS/bin/configure.sh $sflag $oscf >> $obj/.settings$$
  	echo 'divert(0)dnl' >> $obj/.settings$$
! 	sed -e 's/\(.\)include/\1_include_/g' $obj/.settings$$ | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - Makefile.m4 | \
! 		sed 's/_include_/include/g' > $obj/Makefile
  	if [ $? -ne 0 -o ! -s $obj/Makefile ]
  	then
  		echo "ERROR: ${M4} failed; You may need a newer version of M4, at least as new as System V or GNU" 1>&2
--- 470,490 ----
  	fi
  	echo 'divert(0)dnl' >> $obj/.settings$$
  	libdirs=`(cat $obj/.settings$$; echo "_SRIDBIL_= confLIBDIRS" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' -e 's/#define/#_define_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_SRIDBIL_=" | \
! 		sed -e 's/#_define_/#define/g' -e 's/_include_/include/g' -e "s/^_SRIDBIL_=//"`
  	libsrch=`(cat $obj/.settings$$; echo "_HCRSBIL_= confLIBSEARCH" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' -e 's/#define/#_define_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_HCRSBIL_=" | \
! 		sed -e 's/#_define_/#define/g' -e 's/_include_/include/g' -e "s/^_HCRSBIL_=//"`
  	echo 'divert(-1)' >> $obj/.settings$$
  	LIBDIRS="$libdirs" LIBSRCH="$libsrch" SITECONFIG="$siteconfig" sh $BUILDTOOLS/bin/configure.sh $sflag $oscf >> $obj/.settings$$
  	echo 'divert(0)dnl' >> $obj/.settings$$
! 	sed -e 's/\(.\)include/\1_include_/g' -e 's/#define/#_define_/g' $obj/.settings$$ | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - Makefile.m4 | \
! 		sed -e 's/#_define_/#define/g' -e 's/_include_/include/g' > $obj/Makefile
  	if [ $? -ne 0 -o ! -s $obj/Makefile ]
  	then
  		echo "ERROR: ${M4} failed; You may need a newer version of M4, at least as new as System V or GNU" 1>&2
***************
*** 488,504 ****
  		echo "ERROR: $obj exists but has no Makefile" >&2
  		exit $EX_NOINPUT
  	fi
! 	case $makefile
! 	in
! 	  ../Makefiles/*)
! 		makefile=`echo $makefile | sed 's/...Makefiles.//'`
! 		echo "Will run in existing $obj using $makefile"
! 		;;
! 
! 	  *)
! 		echo "Will run in existing $obj using custom $makefile"
! 		;;
! 	esac
  	exit 0
  fi
  
--- 504,510 ----
  		echo "ERROR: $obj exists but has no Makefile" >&2
  		exit $EX_NOINPUT
  	fi
! 	echo "Will run in existing $obj using $makefile"
  	exit 0
  fi
  
diff -cr sendmail-8.9.0/mail.local/Makefile.m4 sendmail-8.9.1/mail.local/Makefile.m4
*** sendmail-8.9.0/mail.local/Makefile.m4	Tue May 19 16:35:36 1998
--- sendmail-8.9.1/mail.local/Makefile.m4	Thu Jun  4 14:27:14 1998
***************
*** 1,7 ****
  #
  #  This Makefile is designed to work on the old "make" program.
  #
! #	@(#)Makefile.m4	8.18	(Berkeley)	5/13/98
  #
  
  # C compiler
--- 1,7 ----
  #
  #  This Makefile is designed to work on the old "make" program.
  #
! #	@(#)Makefile.m4	8.21	(Berkeley)	6/4/98
  #
  
  # C compiler
***************
*** 50,75 ****
  BEFORE=	snprintf.c confBEFORE
  OBJS=	mail.local.o snprintf.o ${OBJADD}
  
- LINKS=	${DESTDIR}/usr/ucb/newaliases ${DESTDIR}/usr/ucb/mailq
- 
- ALL=	mail.local mail.local.0
- 
- all: ${ALL}
- 
- mail.local: ${BEFORE} ${OBJS}
- 	${CC} -o mail.local ${LDOPTS} ${OBJS} ${LIBDIRS} ${LIBS}
- 
- snprintf.c: ${SRCDIR}/snprintf.c
- 	-ln -s ${SRCDIR}/snprintf.c snprintf.c
- 
- undivert(3)
- 
  NROFF=	ifdef(`confNROFF', `confNROFF', `groff -Tascii')
  MANDOC=	ifdef(`confMANDOC', `confMANDOC', `-mandoc')
  
- mail.local.0: mail.local.8
- 	${NROFF} ${MANDOC} mail.local.8 > mail.local.0
- 
  INSTALL=ifdef(`confINSTALL', `confINSTALL', `install')
  BINOWN=	ifdef(`confSBINOWN', `confSBINOWN', `root')
  BINGRP=	ifdef(`confSBINGRP', `confSBINGRP', `bin')
--- 50,58 ----
***************
*** 79,89 ****
  MANGRP=	ifdef(`confMANGRP', `confMANGRP', `bin')
  MANMODE=ifdef(`confMANMODE', `confMANMODE', `444')
  
! MANROOT=ifdef(`confMANROOT', `confMANROOT', `/usr/share/man/cat')
  MAN8=	${MANROOT}ifdef(`confMAN8', `confMAN8', `8')
  MAN8EXT=ifdef(`confMAN8EXT', `confMAN8EXT', `8')
  MAN8SRC=ifdef(`confMAN8SRC', `confMAN8SRC', `0')
  
  install:
  	@echo "NOTE: This version of mail.local is not suited for some operating"
  	@echo "      systems such as HP-UX and Solaris.  Please consult the"
--- 62,87 ----
  MANGRP=	ifdef(`confMANGRP', `confMANGRP', `bin')
  MANMODE=ifdef(`confMANMODE', `confMANMODE', `444')
  
! MANROOT=${DESTDIR}ifdef(`confMANROOT', `confMANROOT', `/usr/share/man/cat')
  MAN8=	${MANROOT}ifdef(`confMAN8', `confMAN8', `8')
  MAN8EXT=ifdef(`confMAN8EXT', `confMAN8EXT', `8')
  MAN8SRC=ifdef(`confMAN8SRC', `confMAN8SRC', `0')
  
+ ALL=	mail.local mail.local.${MAN8SRC}
+ 
+ all: ${ALL}
+ 
+ mail.local: ${BEFORE} ${OBJS}
+ 	${CC} -o mail.local ${LDOPTS} ${OBJS} ${LIBDIRS} ${LIBS}
+ 
+ snprintf.c: ${SRCDIR}/snprintf.c
+ 	-ln -s ${SRCDIR}/snprintf.c snprintf.c
+ 
+ undivert(3)
+ 
+ mail.local.${MAN8SRC}: mail.local.8
+ 	${NROFF} ${MANDOC} mail.local.8 > mail.local.${MAN8SRC}
+ 
  install:
  	@echo "NOTE: This version of mail.local is not suited for some operating"
  	@echo "      systems such as HP-UX and Solaris.  Please consult the"
***************
*** 95,106 ****
  install-mail.local: mail.local
  	${INSTALL} -c -o ${BINOWN} -g ${BINGRP} -m ${BINMODE} mail.local ${BINDIR}
  
! install-docs: mail.local.0
  ifdef(`confNO_MAN_INSTALL', `dnl',
  `	${INSTALL} -c -o ${MANOWN} -g ${MANGRP} -m ${MANMODE} mail.local.${MAN8SRC} ${MAN8}/mail.local.${MAN8EXT}')
  
  clean:
! 	rm -f ${OBJS} mail.local mail.local.0
  
  ################  Dependency scripts
  include(confBUILDTOOLSDIR/M4/depend/ifdef(`confDEPEND_TYPE', `confDEPEND_TYPE', 
--- 93,104 ----
  install-mail.local: mail.local
  	${INSTALL} -c -o ${BINOWN} -g ${BINGRP} -m ${BINMODE} mail.local ${BINDIR}
  
! install-docs: mail.local.${MAN8SRC}
  ifdef(`confNO_MAN_INSTALL', `dnl',
  `	${INSTALL} -c -o ${MANOWN} -g ${MANGRP} -m ${MANMODE} mail.local.${MAN8SRC} ${MAN8}/mail.local.${MAN8EXT}')
  
  clean:
! 	rm -f ${OBJS} mail.local mail.local.${MAN8SRC}
  
  ################  Dependency scripts
  include(confBUILDTOOLSDIR/M4/depend/ifdef(`confDEPEND_TYPE', `confDEPEND_TYPE', 
diff -cr sendmail-8.9.0/mailstats/Build sendmail-8.9.1/mailstats/Build
*** sendmail-8.9.0/mailstats/Build	Tue May 19 16:33:54 1998
--- sendmail-8.9.1/mailstats/Build	Wed Jun 24 21:10:11 1998
***************
*** 10,16 ****
  # the sendmail distribution.
  #
  #
! #       @(#)Build	8.88 (Berkeley) 5/19/98
  #
  
  #
--- 10,16 ----
  # the sendmail distribution.
  #
  #
! #       @(#)Build	8.93 (Berkeley) 6/24/98
  #
  
  #
***************
*** 155,160 ****
--- 155,166 ----
  		rel=Mach
  		arch=luna88k
  	fi
+ elif [ -d /usr/apollo -a -d \`node_data ]
+ then
+ 	# probably a Apollo/DOMAIN
+ 	os=DomainOS
+ 	arch=$ISP
+ 	rel=`/usr/apollo/bin/bldt | grep Domain | awk '{ print $4 }' | sed -e 's/,//g'`
  fi
  
  if [ ! "$arch" -a ! "$os" -a ! "$rel" ]
***************
*** 234,239 ****
--- 240,249 ----
  			rel=`uname -v | sed -e 's/\(V.*\)L.*/\1/'`
  		fi;;
    SINIX-?)	os=SINIX;;
+   DomainOS)	case $rel in
+ 		  10.4*)	rel=10.4;;
+ 		esac
+ 		;;
  esac
  
  # get "base part" of operating system release
***************
*** 296,301 ****
--- 306,317 ----
  BUILDTOOLS=${BUILDTOOLS-$SMROOT/BuildTools}
  export SMROOT BUILDTOOLS
  
+ # see if we are in a Build-able directory
+ if [ ! -f Makefile.m4 ]; then
+ 	echo "Makefile.m4 not found.  Build can only be run from a source directory."
+ 	exit $EX_UNAVAILABLE
+ fi
+ 
  # now try to find a reasonable object directory
  if [ -r obj.$os.$rel.$arch$sfx ]; then
  	obj=obj.$os.$rel.$arch$sfx
***************
*** 436,442 ****
  		fi
  		if [ -f $BUILDTOOLS/Site/site.config.m4 ]
  		then
! 			siteconfig=$BUILDTOOLS/Site/site.config.m4
  		fi
  	fi
  	if [ ! -z "$siteconfig" ]
--- 452,458 ----
  		fi
  		if [ -f $BUILDTOOLS/Site/site.config.m4 ]
  		then
! 			siteconfig="$BUILDTOOLS/Site/site.config.m4 $siteconfig"
  		fi
  	fi
  	if [ ! -z "$siteconfig" ]
***************
*** 454,474 ****
  	fi
  	echo 'divert(0)dnl' >> $obj/.settings$$
  	libdirs=`(cat $obj/.settings$$; echo "_SRIDBIL_= confLIBDIRS" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_SRIDBIL_=" | \
! 		sed -e 's/_include_/include/g' -e "s/^_SRIDBIL_=//"`
  	libsrch=`(cat $obj/.settings$$; echo "_HCRSBIL_= confLIBSEARCH" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_HCRSBIL_=" | \
! 		sed -e 's/_include_/include/g' -e "s/^_HCRSBIL_=//"`
  	echo 'divert(-1)' >> $obj/.settings$$
  	LIBDIRS="$libdirs" LIBSRCH="$libsrch" SITECONFIG="$siteconfig" sh $BUILDTOOLS/bin/configure.sh $sflag $oscf >> $obj/.settings$$
  	echo 'divert(0)dnl' >> $obj/.settings$$
! 	sed -e 's/\(.\)include/\1_include_/g' $obj/.settings$$ | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - Makefile.m4 | \
! 		sed 's/_include_/include/g' > $obj/Makefile
  	if [ $? -ne 0 -o ! -s $obj/Makefile ]
  	then
  		echo "ERROR: ${M4} failed; You may need a newer version of M4, at least as new as System V or GNU" 1>&2
--- 470,490 ----
  	fi
  	echo 'divert(0)dnl' >> $obj/.settings$$
  	libdirs=`(cat $obj/.settings$$; echo "_SRIDBIL_= confLIBDIRS" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' -e 's/#define/#_define_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_SRIDBIL_=" | \
! 		sed -e 's/#_define_/#define/g' -e 's/_include_/include/g' -e "s/^_SRIDBIL_=//"`
  	libsrch=`(cat $obj/.settings$$; echo "_HCRSBIL_= confLIBSEARCH" ) | \
! 		sed -e 's/\(.\)include/\1_include_/g' -e 's/#define/#_define_/g' | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - | \
  		grep "^_HCRSBIL_=" | \
! 		sed -e 's/#_define_/#define/g' -e 's/_include_/include/g' -e "s/^_HCRSBIL_=//"`
  	echo 'divert(-1)' >> $obj/.settings$$
  	LIBDIRS="$libdirs" LIBSRCH="$libsrch" SITECONFIG="$siteconfig" sh $BUILDTOOLS/bin/configure.sh $sflag $oscf >> $obj/.settings$$
  	echo 'divert(0)dnl' >> $obj/.settings$$
! 	sed -e 's/\(.\)include/\1_include_/g' -e 's/#define/#_define_/g' $obj/.settings$$ | \
  		${M4} -DconfBUILDTOOLSDIR=$BUILDTOOLS - Makefile.m4 | \
! 		sed -e 's/#_define_/#define/g' -e 's/_include_/include/g' > $obj/Makefile
  	if [ $? -ne 0 -o ! -s $obj/Makefile ]
  	then
  		echo "ERROR: ${M4} failed; You may need a newer version of M4, at least as new as System V or GNU" 1>&2
***************
*** 488,504 ****
  		echo "ERROR: $obj exists but has no Makefile" >&2
  		exit $EX_NOINPUT
  	fi
! 	case $makefile
! 	in
! 	  ../Makefiles/*)
! 		makefile=`echo $makefile | sed 's/...Makefiles.//'`
! 		echo "Will run in existing $obj using $makefile"
! 		;;
! 
! 	  *)
! 		echo "Will run in existing $obj using custom $makefile"
! 		;;
! 	esac
  	exit 0
  fi
  
--- 504,510 ----
  		echo "ERROR: $obj exists but has no Makefile" >&2
  		exit $EX_NOINPUT
  	fi
! 	echo "Will run in existing $obj using $makefile"
  	exit 0
  fi
  
diff -cr sendmail-8.9.0/mailstats/Makefile.m4 sendmail-8.9.1/mailstats/Makefile.m4
*** sendmail-8.9.0/mailstats/Makefile.m4	Tue May 19 16:35:39 1998
--- sendmail-8.9.1/mailstats/Makefile.m4	Mon Jun  8 14:06:48 1998
***************
*** 1,7 ****
  #
  #  This Makefile is designed to work on the old "make" program.
  #
! #	@(#)Makefile.m4	8.11	(Berkeley)	5/13/98
  #
  
  # C compiler
--- 1,7 ----
  #
  #  This Makefile is designed to work on the old "make" program.
  #
! #	@(#)Makefile.m4	8.14	(Berkeley)	6/4/98
  #
  
  # C compiler
***************
*** 50,70 ****
  BEFORE= confBEFORE
  OBJS=	mailstats.o ${OBJADD}
  
- ALL=	mailstats mailstats.0
- 
- all: ${ALL}
- 
- mailstats: ${BEFORE} ${OBJS}
- 	${CC} -o mailstats ${LDOPTS} ${OBJS} ${LIBDIRS} ${LIBS}
- 
- undivert(3)
- 
  NROFF=	ifdef(`confNROFF', `confNROFF', `groff -Tascii')
  MANDOC=	ifdef(`confMANDOC', `confMANDOC', `-mandoc')
  
- mailstats.0: mailstats.8
- 	${NROFF} ${MANDOC} mailstats.8 > mailstats.0
- 
  INSTALL=ifdef(`confINSTALL', `confINSTALL', `install')
  BINOWN=	ifdef(`confUBINOWN', `confUBINOWN', `bin')
  BINGRP=	ifdef(`confUBINGRP', `confUBINGRP', `bin')
--- 50,58 ----
***************
*** 74,95 ****
  MANGRP=	ifdef(`confMANGRP', `confMANGRP', `bin')
  MANMODE=ifdef(`confMANMODE', `confMANMODE', `444')
  
! MANROOT=ifdef(`confMANROOT', `confMANROOT', `/usr/share/man/cat')
  MAN8=	${MANROOT}ifdef(`confMAN8', `confMAN8', `8')
  MAN8EXT=ifdef(`confMAN8EXT', `confMAN8EXT', `8')
  MAN8SRC=ifdef(`confMAN8SRC', `confMAN8SRC', `0')
  
  install: install-mailstats install-docs
  
  install-mailstats: mailstats
  	${INSTALL} -c -o ${BINOWN} -g ${BINGRP} -m ${BINMODE} mailstats ${BINDIR}
  
! install-docs: mailstats.0
  ifdef(`confNO_MAN_INSTALL', `dnl',
  `	${INSTALL} -c -o ${MANOWN} -g ${MANGRP} -m ${MANMODE} mailstats.${MAN8SRC} ${MAN8}/mailstats.${MAN8EXT}')
  
  clean:
! 	rm -f ${OBJS} mailstats mailstats.0
  
  ################  Dependency scripts
  include(confBUILDTOOLSDIR/M4/depend/ifdef(`confDEPEND_TYPE', `confDEPEND_TYPE',
--- 62,95 ----
  MANGRP=	ifdef(`confMANGRP', `confMANGRP', `bin')
  MANMODE=ifdef(`confMANMODE', `confMANMODE', `444')
  
! MANROOT=${DESTDIR}ifdef(`confMANROOT', `confMANROOT', `/usr/share/man/cat')
  MAN8=	${MANROOT}ifdef(`confMAN8', `confMAN8', `8')
  MAN8EXT=ifdef(`confMAN8EXT', `confMAN8EXT', `8')
  MAN8SRC=ifdef(`confMAN8SRC', `confMAN8SRC', `0')
  
+ ALL=	mailstats mailstats.${MAN8SRC}
+ 
+ all: ${ALL}
+ 
+ mailstats: ${BEFORE} ${OBJS}
+ 	${CC} -o mailstats ${LDOPTS} ${OBJS} ${LIBDIRS} ${LIBS}
+ 
+ undivert(3)
+ 
+ mailstats.${MAN8SRC}: mailstats.8
+ 	${NROFF} ${MANDOC} mailstats.8 > mailstats.${MAN8SRC}
+ 
  install: install-mailstats install-docs
  
  install-mailstats: mailstats
  	${INSTALL} -c -o ${BINOWN} -g ${BINGRP} -m ${BINMODE} mailstats ${BINDIR}
  
! install-docs: mailstats.${MAN8SRC}
  ifdef(`confNO_MAN_INSTALL', `dnl',
  `	${INSTALL} -c -o ${MANOWN} -g ${MANGRP} -m ${MANMODE} mailstats.${MAN8SRC} ${MAN8}/mailstats.${MAN8EXT}')
  
  clean:
! 	rm -f ${OBJS} mailstats mailstats.${MAN8SRC}
  
  ################  Dependency scripts
  include(confBUILDTOOLSDIR/M4/depend/ifdef(`confDEPEND_TYPE', `confDEPEND_TYPE',
diff -cr sendmail-8.9.0/mailstats/mailstats.c sendmail-8.9.1/mailstats/mailstats.c
*** sendmail-8.9.0/mailstats/mailstats.c	Tue May 19 16:35:39 1998
--- sendmail-8.9.1/mailstats/mailstats.c	Thu Jul  2 11:27:59 1998
***************
*** 1,5 ****
  /*
!  * Copyright (c) 1988 Sendmail, Inc.  All rights reserved.
   * Copyright (c) 1983 Eric P. Allman.  All rights reserved.
   * Copyright (c) 1988, 1993
   *	The Regents of the University of California.  All rights reserved.
--- 1,5 ----
  /*
!  * Copyright (c) 1998 Sendmail, Inc.  All rights reserved.
   * Copyright (c) 1983 Eric P. Allman.  All rights reserved.
   * Copyright (c) 1988, 1993
   *	The Regents of the University of California.  All rights reserved.
***************
*** 18,27 ****
  #endif /* not lint */
  
  #ifndef lint
! static char sccsid[] = "@(#)mailstats.c	8.22 (Berkeley) 5/19/98";
  #endif /* not lint */
  
! #define NOT_SENDMAIL
  #include <sendmail.h>
  #include <mailstats.h>
  #include <pathnames.h>
--- 18,29 ----
  #endif /* not lint */
  
  #ifndef lint
! static char sccsid[] = "@(#)mailstats.c	8.26 (Berkeley) 7/2/98";
  #endif /* not lint */
  
! #ifndef NOT_SENDMAIL
! # define NOT_SENDMAIL
! #endif
  #include <sendmail.h>
  #include <mailstats.h>
  #include <pathnames.h>
***************
*** 225,238 ****
  	}
  
  	printf("Statistics from %s", ctime(&stat.stat_itime));
! 	printf(" M msgsfr  bytes_from msgsto    bytes_to  msgsrej msgsdis%s\n",
  		mnames ? "  Mailer" : "");
  	for (i = 0; i < MAXMAILERS; i++)
  	{
  		if (stat.stat_nf[i] || stat.stat_nt[i] ||
  		    stat.stat_nr[i] || stat.stat_nd[i])
  		{
! 			printf("%2d %6ld %10ldK %6ld %10ldK   %6ld  %6ld", i,
  			    stat.stat_nf[i], stat.stat_bf[i],
  			    stat.stat_nt[i], stat.stat_bt[i],
  			    stat.stat_nr[i], stat.stat_nd[i]);
--- 227,240 ----
  	}
  
  	printf("Statistics from %s", ctime(&stat.stat_itime));
! 	printf(" M   msgsfr  bytes_from   msgsto    bytes_to  msgsrej msgsdis%s\n",
  		mnames ? "  Mailer" : "");
  	for (i = 0; i < MAXMAILERS; i++)
  	{
  		if (stat.stat_nf[i] || stat.stat_nt[i] ||
  		    stat.stat_nr[i] || stat.stat_nd[i])
  		{
! 			printf("%2d %8ld %10ldK %8ld %10ldK   %6ld  %6ld", i,
  			    stat.stat_nf[i], stat.stat_bf[i],
  			    stat.stat_nt[i], stat.stat_bt[i],
  			    stat.stat_nr[i], stat.stat_nd[i]);
***************
*** 247,254 ****
  			dismsgs += stat.stat_nd[i];
  		}
  	}
! 	printf("=========================================================\n");
! 	printf(" T %6ld %10ldK %6ld %10ldK   %6ld  %6ld\n",
  		frmsgs, frbytes, tomsgs, tobytes, rejmsgs, dismsgs);
  	exit(EX_OK);
  }
--- 249,256 ----
  			dismsgs += stat.stat_nd[i];
  		}
  	}
! 	printf("=============================================================\n");
! 	printf(" T %8ld %10ldK %8ld %10ldK   %6ld  %6ld\n",
  		frmsgs, frbytes, tomsgs, tobytes, rejmsgs, dismsgs);
  	exit(EX_OK);
  }
